import * as i0 from '@angular/core';
import { ElementRef, Injectable, Component, ViewChild, Input, Directive, NgModule } from '@angular/core';
import * as Prism from 'prismjs';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import 'prismjs/plugins/normalize-whitespace/prism-normalize-whitespace';

class AsPrismService {
    /**
     * @param {ElementRef} el - HTMLELement
     * @param {AsPrismOptions} [options] - Highligher Option
     */
    highlightElement(el, options) {
        if (el instanceof ElementRef) {
            Prism.highlightElement(el.nativeElement, options?.async, options?.callback);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismService, decorators: [{
            type: Injectable
        }] });

class AsPrismComponent {
    constructor(prismService) {
        this.prismService = prismService;
        this.language = 'json';
        this.showCopyBtn = true;
    }
    ngAfterViewInit() {
        this.prismService.highlightElement(this.codeEle);
    }
    ngOnChanges(changes) {
        if (changes?.code) {
            if (this.codeEle?.nativeElement) {
                this.codeEle.nativeElement.textContent = this.code;
                this.prismService.highlightElement(this.codeEle);
            }
        }
    }
    onCopy() {
        navigator.clipboard.writeText(this.code);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismComponent, deps: [{ token: AsPrismService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.0", type: AsPrismComponent, selector: "as-prism", inputs: { code: "code", language: "language", showCopyBtn: "showCopyBtn" }, viewQueries: [{ propertyName: "codeEle", first: true, predicate: ["codeEle"], descendants: true }], usesOnChanges: true, ngImport: i0, template: `
    <pre [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
    <button
      *ngIf="showCopyBtn"
      class="as-prism__copy-btn"
      type="button"
      (click)="onCopy()"
    >
      <svg
        xmlns="http://www.w3.org/2000/svg"
        height="20px"
        viewBox="0 -960 960 960"
        width="20px"
        fill="currentColor"
      >
        <path
          d="M360-240q-29.7 0-50.85-21.15Q288-282.3 288-312v-480q0-29.7 21.15-50.85Q330.3-864 360-864h384q29.7 0 50.85 21.15Q816-821.7 816-792v480q0 29.7-21.15 50.85Q773.7-240 744-240H360Zm0-72h384v-480H360v480ZM216-96q-29.7 0-50.85-21.15Q144-138.3 144-168v-552h72v552h456v72H216Zm144-216v-480 480Z"
        />
      </svg>
    </button>
  `, isInline: true, styles: [":host{position:relative;display:block}:host:hover .as-prism__copy-btn{opacity:1}.as-prism__copy-btn{position:absolute;right:20px;top:20px;cursor:pointer;opacity:0;transition:opacity .2s ease-in;height:30px;width:30px;line-height:38px;padding:0;text-align:center}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismComponent, decorators: [{
            type: Component,
            args: [{ selector: 'as-prism', template: `
    <pre [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
    <button
      *ngIf="showCopyBtn"
      class="as-prism__copy-btn"
      type="button"
      (click)="onCopy()"
    >
      <svg
        xmlns="http://www.w3.org/2000/svg"
        height="20px"
        viewBox="0 -960 960 960"
        width="20px"
        fill="currentColor"
      >
        <path
          d="M360-240q-29.7 0-50.85-21.15Q288-282.3 288-312v-480q0-29.7 21.15-50.85Q330.3-864 360-864h384q29.7 0 50.85 21.15Q816-821.7 816-792v480q0 29.7-21.15 50.85Q773.7-240 744-240H360Zm0-72h384v-480H360v480ZM216-96q-29.7 0-50.85-21.15Q144-138.3 144-168v-552h72v552h456v72H216Zm144-216v-480 480Z"
        />
      </svg>
    </button>
  `, styles: [":host{position:relative;display:block}:host:hover .as-prism__copy-btn{opacity:1}.as-prism__copy-btn{position:absolute;right:20px;top:20px;cursor:pointer;opacity:0;transition:opacity .2s ease-in;height:30px;width:30px;line-height:38px;padding:0;text-align:center}\n"] }]
        }], ctorParameters: () => [{ type: AsPrismService }], propDecorators: { codeEle: [{
                type: ViewChild,
                args: ['codeEle']
            }], code: [{
                type: Input
            }], language: [{
                type: Input
            }], showCopyBtn: [{
                type: Input
            }] } });

/**
 * @description highlight with directive
 * @DevelopmentApi
 */
class AsPrismDirective {
    constructor(el, asPrismService) {
        this.el = el;
        this.asPrismService = asPrismService;
        this.asPrism = 'json';
        // console.log('el', this.el)
    }
    ngAfterViewInit() {
        this.el.nativeElement.classList.add(`language-${this.asPrism}`);
        // console.log(this.el)
        // this.asPrismService.highlightElement(this.el)
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismDirective, deps: [{ token: i0.ElementRef }, { token: AsPrismService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.0", type: AsPrismDirective, selector: "pre[asPrism]", inputs: { asPrism: "asPrism" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'pre[asPrism]',
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: AsPrismService }], propDecorators: { asPrism: [{
                type: Input
            }] } });

class AsPrismModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.0", ngImport: i0, type: AsPrismModule, declarations: [AsPrismComponent, AsPrismDirective], imports: [CommonModule], exports: [AsPrismComponent, AsPrismDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismModule, providers: [AsPrismService], imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.0", ngImport: i0, type: AsPrismModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AsPrismComponent, AsPrismDirective],
                    imports: [CommonModule],
                    exports: [AsPrismComponent, AsPrismDirective],
                    providers: [AsPrismService],
                }]
        }] });

/*
 * Public API Surface of as-prism
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AsPrismComponent, AsPrismDirective, AsPrismModule, AsPrismService };
//# sourceMappingURL=as-prism.mjs.map
